<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.jbase;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataOutputStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.File;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.FileNotFoundException;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.FilenameFilter;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.IOException;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.Map;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.util.concurrent.ConcurrentHashMap;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.util.concurrent.locks.ReadWriteLock;<a name="line.43"></a>
<FONT color="green">044</FONT>    <a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.jbase.concurrent.ConcurrentTable;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.jbase.concurrent.Stateful;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.jbase.util.UnsupportedOperationException;<a name="line.47"></a>
<FONT color="green">048</FONT>    <a name="line.48"></a>
<FONT color="green">049</FONT>    <a name="line.49"></a>
<FONT color="green">050</FONT>    <a name="line.50"></a>
<FONT color="green">051</FONT>    /**<a name="line.51"></a>
<FONT color="green">052</FONT>     * The &lt;code&gt;VariableWidthTablePaired&lt;/code&gt; stores entities of unknown, <a name="line.52"></a>
<FONT color="green">053</FONT>     * variable size. A pair of tables is used to store the rows. If necessary, a <a name="line.53"></a>
<FONT color="green">054</FONT>     * pointer in the first table points to the entry in another table of sufficient<a name="line.54"></a>
<FONT color="green">055</FONT>     * row width.<a name="line.55"></a>
<FONT color="green">056</FONT>     * &lt;p&gt;<a name="line.56"></a>
<FONT color="green">057</FONT>     * Multiple files are used to store the data, each file controlled by a<a name="line.57"></a>
<FONT color="green">058</FONT>     * {@link FixedWidthTable}. The primary table contains raw data plus two <a name="line.58"></a>
<FONT color="green">059</FONT>     * additional indices pointing to an entry of the secondary table (one index for<a name="line.59"></a>
<FONT color="green">060</FONT>     * the table, one for the row in the table). Multiple secondary tables of <a name="line.60"></a>
<FONT color="green">061</FONT>     * different sizes exist, each storing raw data plus an index back to the row<a name="line.61"></a>
<FONT color="green">062</FONT>     * of the primary table (needed for deletions). The widths of the secondary <a name="line.62"></a>
<FONT color="green">063</FONT>     * tables are powers of two. The smallest possible secondary table is used<a name="line.63"></a>
<FONT color="green">064</FONT>     * and created if not yet existing.<a name="line.64"></a>
<FONT color="green">065</FONT>     * &lt;p&gt;<a name="line.65"></a>
<FONT color="green">066</FONT>     * Note that variable width tables are not thread safe. However, a thread safe <a name="line.66"></a>
<FONT color="green">067</FONT>     * table for concurrent use is possible by using this table together with<a name="line.67"></a>
<FONT color="green">068</FONT>     * {@link ConcurrentTable}.<a name="line.68"></a>
<FONT color="green">069</FONT>     */<a name="line.69"></a>
<FONT color="green">070</FONT>    public class VariableWidthTable&lt;E&gt; implements Table&lt;E&gt;, Stateful {<a name="line.70"></a>
<FONT color="green">071</FONT>        <a name="line.71"></a>
<FONT color="green">072</FONT>        private final File                                  folder;<a name="line.72"></a>
<FONT color="green">073</FONT>        private final String                                fileName;<a name="line.73"></a>
<FONT color="green">074</FONT>        private final EntityMarshaller&lt;E&gt;                   entityMarshaller;  <a name="line.74"></a>
<FONT color="green">075</FONT>        private final int                                                                   cacheTableSize;<a name="line.75"></a>
<FONT color="green">076</FONT>        private final int                                                                   cacheEntrySize;<a name="line.76"></a>
<FONT color="green">077</FONT>        private volatile FixedWidthTable&lt;FixedTableRow&gt;     primaryTable;<a name="line.77"></a>
<FONT color="green">078</FONT>        <a name="line.78"></a>
<FONT color="green">079</FONT>        private final Map&lt;File, FixedWidthTable&lt;FixedTableRow&gt;&gt; secondaryTables;<a name="line.79"></a>
<FONT color="green">080</FONT>    <a name="line.80"></a>
<FONT color="green">081</FONT>        private final ByteArray byteBuffer;                 <a name="line.81"></a>
<FONT color="green">082</FONT>        <a name="line.82"></a>
<FONT color="green">083</FONT>        /**<a name="line.83"></a>
<FONT color="green">084</FONT>         * Constructor, only for subclassing, use the static <a name="line.84"></a>
<FONT color="green">085</FONT>         * {@link #create(File, String, int, EntityMarshaller, int, int) create} and <a name="line.85"></a>
<FONT color="green">086</FONT>         * {@link #open(File, String, EntityMarshaller, int, int) open} methods to create <a name="line.86"></a>
<FONT color="green">087</FONT>         * instances.<a name="line.87"></a>
<FONT color="green">088</FONT>         * <a name="line.88"></a>
<FONT color="green">089</FONT>         * @param folder            The folder containing the table files<a name="line.89"></a>
<FONT color="green">090</FONT>         * @param fileName          The file name of the tables. Indexing is inserted<a name="line.90"></a>
<FONT color="green">091</FONT>         *                          in front of the file ending if needed. <a name="line.91"></a>
<FONT color="green">092</FONT>         * @param entityMarshaller  The marshaller transforming entities (rows) into bytes  <a name="line.92"></a>
<FONT color="green">093</FONT>         * @param cacheTableSize    Table size for {@link BufferedRandomAccessPersister},<a name="line.93"></a>
<FONT color="green">094</FONT>         *                                                  or 0 if no cache should be used<a name="line.94"></a>
<FONT color="green">095</FONT>         * @param cacheEntrySize    Table entry size for {@link BufferedRandomAccessPersister},<a name="line.95"></a>
<FONT color="green">096</FONT>         *                                                  or 0 if no cache should be used<a name="line.96"></a>
<FONT color="green">097</FONT>         */<a name="line.97"></a>
<FONT color="green">098</FONT>        protected VariableWidthTable(File folder, String fileName, EntityMarshaller&lt;E&gt; entityMarshaller, int cacheTableSize, int cacheEntrySize) {<a name="line.98"></a>
<FONT color="green">099</FONT>            this.folder             = folder;<a name="line.99"></a>
<FONT color="green">100</FONT>            this.fileName           = fileName;<a name="line.100"></a>
<FONT color="green">101</FONT>            this.entityMarshaller   = entityMarshaller;<a name="line.101"></a>
<FONT color="green">102</FONT>            this.cacheTableSize             = cacheTableSize;<a name="line.102"></a>
<FONT color="green">103</FONT>            this.cacheEntrySize             = cacheEntrySize;<a name="line.103"></a>
<FONT color="green">104</FONT>            this.secondaryTables    = new ConcurrentHashMap&lt;File, FixedWidthTable&lt;FixedTableRow&gt;&gt;();<a name="line.104"></a>
<FONT color="green">105</FONT>            this.byteBuffer                 = new ByteArray();<a name="line.105"></a>
<FONT color="green">106</FONT>        }<a name="line.106"></a>
<FONT color="green">107</FONT>    <a name="line.107"></a>
<FONT color="green">108</FONT>        /**<a name="line.108"></a>
<FONT color="green">109</FONT>         * Opens existing variable table files.<a name="line.109"></a>
<FONT color="green">110</FONT>         * <a name="line.110"></a>
<FONT color="green">111</FONT>         * @param folder            The folder containing the table files<a name="line.111"></a>
<FONT color="green">112</FONT>         * @param fileName          The file name of the tables. Indexing is inserted<a name="line.112"></a>
<FONT color="green">113</FONT>         *                          in front of the file ending if needed. <a name="line.113"></a>
<FONT color="green">114</FONT>         * @param entityMarshaller  The marshaller transforming entities (rows) into bytes  <a name="line.114"></a>
<FONT color="green">115</FONT>         * @param cacheTableSize    Table size for {@link BufferedRandomAccessPersister},<a name="line.115"></a>
<FONT color="green">116</FONT>         *                                                  or 0 if no cache should be used<a name="line.116"></a>
<FONT color="green">117</FONT>         * @param cacheEntrySize    Table entry size for {@link BufferedRandomAccessPersister},<a name="line.117"></a>
<FONT color="green">118</FONT>         *                                                  or 0 if no cache should be used<a name="line.118"></a>
<FONT color="green">119</FONT>         */<a name="line.119"></a>
<FONT color="green">120</FONT>        public static &lt;En&gt; VariableWidthTable&lt;En&gt; open(File folder, String fileName, EntityMarshaller&lt;En&gt; entityMarshaller, int cacheTableSize, int cacheEntrySize) throws IOException {<a name="line.120"></a>
<FONT color="green">121</FONT>            final VariableWidthTable&lt;En&gt; tbl = new VariableWidthTable&lt;En&gt;(folder, fileName, entityMarshaller, cacheTableSize, cacheEntrySize);<a name="line.121"></a>
<FONT color="green">122</FONT>            tbl.primaryTable = tbl.openPrimaryTable();<a name="line.122"></a>
<FONT color="green">123</FONT>            return tbl;<a name="line.123"></a>
<FONT color="green">124</FONT>        }<a name="line.124"></a>
<FONT color="green">125</FONT>        /**<a name="line.125"></a>
<FONT color="green">126</FONT>         * Creates new variable table files, erasing existing files if existent. <a name="line.126"></a>
<FONT color="green">127</FONT>         * &lt;p&gt;<a name="line.127"></a>
<FONT color="green">128</FONT>         * The width of the primary table controls the frequency of single/double table <a name="line.128"></a>
<FONT color="green">129</FONT>         * accesses versus gaps in the primary table. If the primary table is wide, the <a name="line.129"></a>
<FONT color="green">130</FONT>         * majority of accesses only concern the primary table, but many rows might only <a name="line.130"></a>
<FONT color="green">131</FONT>         * use a small portion of the fixed row width. If the primary table is small, less <a name="line.131"></a>
<FONT color="green">132</FONT>         * disk space is needed, but secondary table accesses are more likely.<a name="line.132"></a>
<FONT color="green">133</FONT>         * <a name="line.133"></a>
<FONT color="green">134</FONT>         * @param folder            The folder containing the table files<a name="line.134"></a>
<FONT color="green">135</FONT>         * @param fileName          The file name of the tables. Indexing is inserted<a name="line.135"></a>
<FONT color="green">136</FONT>         *                          in front of the file ending if needed. <a name="line.136"></a>
<FONT color="green">137</FONT>         * @param firstTableByteWidth   The byte width of the primary table, without<a name="line.137"></a>
<FONT color="green">138</FONT>         *                              index widths for indices to secondary tables<a name="line.138"></a>
<FONT color="green">139</FONT>         * @param entityMarshaller  The marshaller transforming entities (rows) into bytes  <a name="line.139"></a>
<FONT color="green">140</FONT>         * @param cacheTableSize    Table size for {@link BufferedRandomAccessPersister},<a name="line.140"></a>
<FONT color="green">141</FONT>         *                                                  or 0 if no cache should be used<a name="line.141"></a>
<FONT color="green">142</FONT>         * @param cacheEntrySize    Table entry size for {@link BufferedRandomAccessPersister},<a name="line.142"></a>
<FONT color="green">143</FONT>         *                                                  or 0 if no cache should be used<a name="line.143"></a>
<FONT color="green">144</FONT>         */<a name="line.144"></a>
<FONT color="green">145</FONT>        public static &lt;En&gt; VariableWidthTable&lt;En&gt; create(File folder, String fileName, int firstTableByteWidth, EntityMarshaller&lt;En&gt; entityMarshaller, int cacheTableSize, int cacheEntrySize) throws IOException {<a name="line.145"></a>
<FONT color="green">146</FONT>            final VariableWidthTable&lt;En&gt; tbl = new VariableWidthTable&lt;En&gt;(folder, fileName, entityMarshaller, cacheTableSize, cacheEntrySize);<a name="line.146"></a>
<FONT color="green">147</FONT>            eraseTableFiles(folder, fileName);<a name="line.147"></a>
<FONT color="green">148</FONT>            tbl.primaryTable = tbl.createPrimaryTable(firstTableByteWidth);<a name="line.148"></a>
<FONT color="green">149</FONT>            return tbl;<a name="line.149"></a>
<FONT color="green">150</FONT>        }<a name="line.150"></a>
<FONT color="green">151</FONT>        <a name="line.151"></a>
<FONT color="green">152</FONT>        private static void eraseTableFiles(File folder, String fileName) {<a name="line.152"></a>
<FONT color="green">153</FONT>            final String prefix     = getFileNamePrefix(fileName);<a name="line.153"></a>
<FONT color="green">154</FONT>            final String postfix    = getFileNamePostfix(fileName);<a name="line.154"></a>
<FONT color="green">155</FONT>            final File[] files = folder.listFiles(new FilenameFilter() {<a name="line.155"></a>
<FONT color="green">156</FONT>                    public boolean accept(File dir, String name) {<a name="line.156"></a>
<FONT color="green">157</FONT>                            return name.startsWith(prefix) &amp;&amp; name.endsWith(postfix);<a name="line.157"></a>
<FONT color="green">158</FONT>                    }<a name="line.158"></a>
<FONT color="green">159</FONT>            });<a name="line.159"></a>
<FONT color="green">160</FONT>            for (final File file : files) {<a name="line.160"></a>
<FONT color="green">161</FONT>                    file.delete();<a name="line.161"></a>
<FONT color="green">162</FONT>            }        <a name="line.162"></a>
<FONT color="green">163</FONT>        }<a name="line.163"></a>
<FONT color="green">164</FONT>        <a name="line.164"></a>
<FONT color="green">165</FONT>        private FixedWidthTable&lt;FixedTableRow&gt; openPrimaryTable() throws IOException {<a name="line.165"></a>
<FONT color="green">166</FONT>            return openTableFile(0, -1, false);<a name="line.166"></a>
<FONT color="green">167</FONT>        }<a name="line.167"></a>
<FONT color="green">168</FONT>        private FixedWidthTable&lt;FixedTableRow&gt; createPrimaryTable(int rawByteWidth) throws IOException {<a name="line.168"></a>
<FONT color="green">169</FONT>            final int byteWidth = getTableByteWidth(0, rawByteWidth);<a name="line.169"></a>
<FONT color="green">170</FONT>            return openTableFile(0, byteWidth, true);<a name="line.170"></a>
<FONT color="green">171</FONT>        }<a name="line.171"></a>
<FONT color="green">172</FONT>        private FixedWidthTable&lt;FixedTableRow&gt; openSecondaryTable(int rawByteWidth, boolean createIfNeeded) throws IOException {<a name="line.172"></a>
<FONT color="green">173</FONT>            final int byteWidth = getTableByteWidth(1, rawByteWidth);<a name="line.173"></a>
<FONT color="green">174</FONT>            final File file = getTableFile(1, byteWidth);<a name="line.174"></a>
<FONT color="green">175</FONT>            FixedWidthTable&lt;FixedTableRow&gt; tbl = secondaryTables.get(file);<a name="line.175"></a>
<FONT color="green">176</FONT>            if (tbl == null) {<a name="line.176"></a>
<FONT color="green">177</FONT>                    tbl = openTableFile(1, byteWidth, createIfNeeded);<a name="line.177"></a>
<FONT color="green">178</FONT>                    secondaryTables.put(file, tbl);<a name="line.178"></a>
<FONT color="green">179</FONT>            }<a name="line.179"></a>
<FONT color="green">180</FONT>            return tbl;<a name="line.180"></a>
<FONT color="green">181</FONT>        }<a name="line.181"></a>
<FONT color="green">182</FONT>        private RandomAccessPersister createRandomAccessPersister(File file) throws FileNotFoundException {<a name="line.182"></a>
<FONT color="green">183</FONT>            if (cacheTableSize &gt; 0 &amp;&amp; cacheEntrySize &gt; 0) {<a name="line.183"></a>
<FONT color="green">184</FONT>                    return new BufferedRandomAccessPersister(file, cacheTableSize, cacheEntrySize);<a name="line.184"></a>
<FONT color="green">185</FONT>            }<a name="line.185"></a>
<FONT color="green">186</FONT>            return new RandomAccessFilePersistor(file);<a name="line.186"></a>
<FONT color="green">187</FONT>        }<a name="line.187"></a>
<FONT color="green">188</FONT>        protected FixedWidthTable&lt;FixedTableRow&gt; openTableFile(int tableIndex, int byteWidth, boolean createIfNeeded) throws IOException {<a name="line.188"></a>
<FONT color="green">189</FONT>            final File file = getTableFile(tableIndex, byteWidth);<a name="line.189"></a>
<FONT color="green">190</FONT>            if (file.exists()) {<a name="line.190"></a>
<FONT color="green">191</FONT>                final RandomAccessPersister rap = createRandomAccessPersister(file);<a name="line.191"></a>
<FONT color="green">192</FONT>                final int width = FixedWidthTable.readByteWidth(rap);<a name="line.192"></a>
<FONT color="green">193</FONT>                if (byteWidth &gt;= 0 &amp;&amp; width != getTotalByteWidth(tableIndex, byteWidth)) {<a name="line.193"></a>
<FONT color="green">194</FONT>                    throw new IOException("table file has unexpected byte width, expected " + getTotalByteWidth(tableIndex, byteWidth) + " but found " + width + " for file " + file.getAbsolutePath());<a name="line.194"></a>
<FONT color="green">195</FONT>                }<a name="line.195"></a>
<FONT color="green">196</FONT>                final FixedTableRow row = FixedTableRow.getByTotalByteWidth(width, getTableIndexCount(tableIndex));<a name="line.196"></a>
<FONT color="green">197</FONT>                return FixedWidthTable.open(rap, row);<a name="line.197"></a>
<FONT color="green">198</FONT>            }<a name="line.198"></a>
<FONT color="green">199</FONT>            else {<a name="line.199"></a>
<FONT color="green">200</FONT>                    if (createIfNeeded) {<a name="line.200"></a>
<FONT color="green">201</FONT>                    final RandomAccessPersister rap = createRandomAccessPersister(file);<a name="line.201"></a>
<FONT color="green">202</FONT>    //                final int width = getTableByteWidth(tableIndex, byteWidth);<a name="line.202"></a>
<FONT color="green">203</FONT>                    final int width = byteWidth;<a name="line.203"></a>
<FONT color="green">204</FONT>                    final FixedTableRow row = FixedTableRow.getByByteArrayLength(width, getTableIndexCount(tableIndex));<a name="line.204"></a>
<FONT color="green">205</FONT>                    final FixedWidthTable&lt;FixedTableRow&gt; tbl = FixedWidthTable.create(rap, row);<a name="line.205"></a>
<FONT color="green">206</FONT>                    tbl.flush();//ensure that the byte width is flushed<a name="line.206"></a>
<FONT color="green">207</FONT>                    return tbl;<a name="line.207"></a>
<FONT color="green">208</FONT>                    }<a name="line.208"></a>
<FONT color="green">209</FONT>                    else {<a name="line.209"></a>
<FONT color="green">210</FONT>                            throw new IOException("no such table: " + file.getAbsolutePath());<a name="line.210"></a>
<FONT color="green">211</FONT>                    }<a name="line.211"></a>
<FONT color="green">212</FONT>            }<a name="line.212"></a>
<FONT color="green">213</FONT>        }<a name="line.213"></a>
<FONT color="green">214</FONT>        <a name="line.214"></a>
<FONT color="green">215</FONT>        protected static String getFileNamePrefix(String fileName) {<a name="line.215"></a>
<FONT color="green">216</FONT>            final int lastDot = fileName.lastIndexOf('.');<a name="line.216"></a>
<FONT color="green">217</FONT>            return lastDot &lt; 0 ? fileName : fileName.substring(0, lastDot);<a name="line.217"></a>
<FONT color="green">218</FONT>        }<a name="line.218"></a>
<FONT color="green">219</FONT>        protected static String getFileNamePostfix(String fileName) {<a name="line.219"></a>
<FONT color="green">220</FONT>            final int lastDot = fileName.lastIndexOf('.');<a name="line.220"></a>
<FONT color="green">221</FONT>            return lastDot &lt; 0 ? "" : fileName.substring(lastDot);<a name="line.221"></a>
<FONT color="green">222</FONT>        }<a name="line.222"></a>
<FONT color="green">223</FONT>        protected File getTableFile(int tableIndex, int byteWidth) {<a name="line.223"></a>
<FONT color="green">224</FONT>            if (tableIndex == 0) {<a name="line.224"></a>
<FONT color="green">225</FONT>                    return new File(folder, fileName); <a name="line.225"></a>
<FONT color="green">226</FONT>            }<a name="line.226"></a>
<FONT color="green">227</FONT>            final int lastDot = fileName.lastIndexOf('.');<a name="line.227"></a>
<FONT color="green">228</FONT>            if (lastDot &lt; 0) {<a name="line.228"></a>
<FONT color="green">229</FONT>                return new File(folder, fileName + byteWidth);<a name="line.229"></a>
<FONT color="green">230</FONT>            }<a name="line.230"></a>
<FONT color="green">231</FONT>            return new File(folder, fileName.substring(0, lastDot) + byteWidth + fileName.substring(lastDot));<a name="line.231"></a>
<FONT color="green">232</FONT>        }<a name="line.232"></a>
<FONT color="green">233</FONT>        <a name="line.233"></a>
<FONT color="green">234</FONT>        protected static int getTotalByteWidth(int tableIndex, int byteWidth) {<a name="line.234"></a>
<FONT color="green">235</FONT>            return byteWidth + 4*getTableIndexCount(tableIndex);<a name="line.235"></a>
<FONT color="green">236</FONT>        }<a name="line.236"></a>
<FONT color="green">237</FONT>        protected static int getTableIndexCount(int tableIndex) {<a name="line.237"></a>
<FONT color="green">238</FONT>            return tableIndex == 0 ? 2 : 1;<a name="line.238"></a>
<FONT color="green">239</FONT>        }   <a name="line.239"></a>
<FONT color="green">240</FONT>        <a name="line.240"></a>
<FONT color="green">241</FONT>        /**<a name="line.241"></a>
<FONT color="green">242</FONT>         *<a name="line.242"></a>
<FONT color="green">243</FONT>         */<a name="line.243"></a>
<FONT color="green">244</FONT>        protected static int getTableByteWidth(int tableIndex, int rawByteWidth) throws IOException {<a name="line.244"></a>
<FONT color="green">245</FONT>            int width;<a name="line.245"></a>
<FONT color="green">246</FONT>            if (tableIndex == 0) {<a name="line.246"></a>
<FONT color="green">247</FONT>                    // we want next larger size dividable by 4<a name="line.247"></a>
<FONT color="green">248</FONT>                    width = 4 * ((rawByteWidth + 3) / 4); <a name="line.248"></a>
<FONT color="green">249</FONT>            }<a name="line.249"></a>
<FONT color="green">250</FONT>            else {<a name="line.250"></a>
<FONT color="green">251</FONT>                    // we want powers of two<a name="line.251"></a>
<FONT color="green">252</FONT>                    width = 4;<a name="line.252"></a>
<FONT color="green">253</FONT>                    while (width &lt; rawByteWidth &amp;&amp; width &gt; 0) {<a name="line.253"></a>
<FONT color="green">254</FONT>                    width &lt;&lt;= 1;<a name="line.254"></a>
<FONT color="green">255</FONT>                }<a name="line.255"></a>
<FONT color="green">256</FONT>            }<a name="line.256"></a>
<FONT color="green">257</FONT>            if (width &lt; rawByteWidth) {<a name="line.257"></a>
<FONT color="green">258</FONT>                    //overflow<a name="line.258"></a>
<FONT color="green">259</FONT>                    throw new IOException("table width overflow: " + rawByteWidth);<a name="line.259"></a>
<FONT color="green">260</FONT>            }<a name="line.260"></a>
<FONT color="green">261</FONT>            return width;<a name="line.261"></a>
<FONT color="green">262</FONT>        }<a name="line.262"></a>
<FONT color="green">263</FONT>        <a name="line.263"></a>
<FONT color="green">264</FONT>        // primary[0..n-3]: raw data<a name="line.264"></a>
<FONT color="green">265</FONT>        // primary[n-2]:    size of secondary table (power of 2), or 0 if data fits <a name="line.265"></a>
<FONT color="green">266</FONT>        //                                  into primary table (identifies secondary table)<a name="line.266"></a>
<FONT color="green">267</FONT>        // primary[n-1]:    index in secondary table, or 0 if data fits into primary<a name="line.267"></a>
<FONT color="green">268</FONT>        <a name="line.268"></a>
<FONT color="green">269</FONT>        // secondary[0..n-2]:       raw data        <a name="line.269"></a>
<FONT color="green">270</FONT>        // secondary[n-1]:          index in primary table  <a name="line.270"></a>
<FONT color="green">271</FONT>        <a name="line.271"></a>
<FONT color="green">272</FONT>        public int add(E entity) throws IOException {<a name="line.272"></a>
<FONT color="green">273</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.273"></a>
<FONT color="green">274</FONT>    <a name="line.274"></a>
<FONT color="green">275</FONT>            byteBuffer.reset();<a name="line.275"></a>
<FONT color="green">276</FONT>    //        final DataOutputStream das = new DataOutputStream(byteBuffer);<a name="line.276"></a>
<FONT color="green">277</FONT>            final DataOutputStream das = byteBuffer.getDataOutputStream();<a name="line.277"></a>
<FONT color="green">278</FONT>            entityMarshaller.writeTo(entity, das);<a name="line.278"></a>
<FONT color="green">279</FONT>            das.flush();<a name="line.279"></a>
<FONT color="green">280</FONT>            <a name="line.280"></a>
<FONT color="green">281</FONT>            // write to primary table<a name="line.281"></a>
<FONT color="green">282</FONT>            FixedTableRow row0 = (FixedTableRow)primaryTable.getEntityMarshaller();<a name="line.282"></a>
<FONT color="green">283</FONT>            row0.getBytesFrom(byteBuffer);<a name="line.283"></a>
<FONT color="green">284</FONT>            <a name="line.284"></a>
<FONT color="green">285</FONT>            final int remainingBytes = byteBuffer.getLength();<a name="line.285"></a>
<FONT color="green">286</FONT>            if (remainingBytes != 0) {<a name="line.286"></a>
<FONT color="green">287</FONT>                    final FixedWidthTable&lt;FixedTableRow&gt; secondaryTable = openSecondaryTable(<a name="line.287"></a>
<FONT color="green">288</FONT>                                    remainingBytes, true /*createIfNeeded*/);<a name="line.288"></a>
<FONT color="green">289</FONT>                FixedTableRow row1 = (FixedTableRow)secondaryTable.getEntityMarshaller();<a name="line.289"></a>
<FONT color="green">290</FONT>                row1.getBytesFrom(byteBuffer);<a name="line.290"></a>
<FONT color="green">291</FONT>                row1.setInt(0, primaryTable.size());<a name="line.291"></a>
<FONT color="green">292</FONT>                if (!byteBuffer.isEmpty()) {<a name="line.292"></a>
<FONT color="green">293</FONT>                    throw new IOException("internal error, buffer not empty after flushing to secondary table"); <a name="line.293"></a>
<FONT color="green">294</FONT>                }<a name="line.294"></a>
<FONT color="green">295</FONT>                final int index1 = secondaryTable.size();<a name="line.295"></a>
<FONT color="green">296</FONT>                secondaryTable.add(row1);<a name="line.296"></a>
<FONT color="green">297</FONT>                row0.setInt(0, row1.getByteArrayLength());<a name="line.297"></a>
<FONT color="green">298</FONT>                row0.setInt(1, index1);<a name="line.298"></a>
<FONT color="green">299</FONT>    //            if (index1 &lt; 10 &amp;&amp; secondaryTable.getByteWidth() == 4) {<a name="line.299"></a>
<FONT color="green">300</FONT>    //                System.out.println("w[" + primaryTable.size() + <a name="line.300"></a>
<FONT color="green">301</FONT>    //                        "/" + secondaryTable.size() + "] = " + row0.toString() + row1);<a name="line.301"></a>
<FONT color="green">302</FONT>    //            }<a name="line.302"></a>
<FONT color="green">303</FONT>            }<a name="line.303"></a>
<FONT color="green">304</FONT>            else {<a name="line.304"></a>
<FONT color="green">305</FONT>                    row0.setInt(0, 0);<a name="line.305"></a>
<FONT color="green">306</FONT>                    row0.setInt(1, 0);<a name="line.306"></a>
<FONT color="green">307</FONT>            }<a name="line.307"></a>
<FONT color="green">308</FONT>            return primaryTable.add(row0);<a name="line.308"></a>
<FONT color="green">309</FONT>        }<a name="line.309"></a>
<FONT color="green">310</FONT>    <a name="line.310"></a>
<FONT color="green">311</FONT>        public void close(boolean erase) throws IOException {       <a name="line.311"></a>
<FONT color="green">312</FONT>            if (primaryTable != null) {<a name="line.312"></a>
<FONT color="green">313</FONT>                    for (final FixedWidthTable&lt;FixedTableRow&gt; tbl : secondaryTables.values()) {<a name="line.313"></a>
<FONT color="green">314</FONT>                            tbl.close(erase);<a name="line.314"></a>
<FONT color="green">315</FONT>                    }<a name="line.315"></a>
<FONT color="green">316</FONT>                    primaryTable.close(erase);<a name="line.316"></a>
<FONT color="green">317</FONT>                    secondaryTables.clear();<a name="line.317"></a>
<FONT color="green">318</FONT>                    primaryTable = null;<a name="line.318"></a>
<FONT color="green">319</FONT>            }<a name="line.319"></a>
<FONT color="green">320</FONT>        }<a name="line.320"></a>
<FONT color="green">321</FONT>    <a name="line.321"></a>
<FONT color="green">322</FONT>        public void flush() throws IOException {<a name="line.322"></a>
<FONT color="green">323</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.323"></a>
<FONT color="green">324</FONT>            for (final FixedWidthTable&lt;FixedTableRow&gt; tbl : secondaryTables.values()) {<a name="line.324"></a>
<FONT color="green">325</FONT>                    tbl.flush();<a name="line.325"></a>
<FONT color="green">326</FONT>            }<a name="line.326"></a>
<FONT color="green">327</FONT>            primaryTable.flush();<a name="line.327"></a>
<FONT color="green">328</FONT>        }<a name="line.328"></a>
<FONT color="green">329</FONT>        /**<a name="line.329"></a>
<FONT color="green">330</FONT>         * Calls {@link #close(boolean)} with false argument, i.e. without erasing<a name="line.330"></a>
<FONT color="green">331</FONT>         */<a name="line.331"></a>
<FONT color="green">332</FONT>        @Override<a name="line.332"></a>
<FONT color="green">333</FONT>        protected void finalize() throws Throwable {<a name="line.333"></a>
<FONT color="green">334</FONT>            close(false);<a name="line.334"></a>
<FONT color="green">335</FONT>        }<a name="line.335"></a>
<FONT color="green">336</FONT>        <a name="line.336"></a>
<FONT color="green">337</FONT>        @SuppressWarnings("unchecked")<a name="line.337"></a>
<FONT color="green">338</FONT>        private EntityMarshaller&lt;E&gt; createReadCopyMarshaller(final ReadWriteLock lock) throws IOException {<a name="line.338"></a>
<FONT color="green">339</FONT>            return entityMarshaller instanceof Stateful ?<a name="line.339"></a>
<FONT color="green">340</FONT>                (EntityMarshaller&lt;E&gt;)((Stateful)entityMarshaller).createReadCopy(lock) : entityMarshaller;<a name="line.340"></a>
<FONT color="green">341</FONT>        }<a name="line.341"></a>
<FONT color="green">342</FONT>        public VariableWidthTable&lt;E&gt; createReadCopy(final ReadWriteLock lock) throws IOException {<a name="line.342"></a>
<FONT color="green">343</FONT>            final EntityMarshaller&lt;E&gt; marshaller = createReadCopyMarshaller(lock);<a name="line.343"></a>
<FONT color="green">344</FONT>            final VariableWidthTable&lt;E&gt; tbl = new VariableWidthTable&lt;E&gt;(folder, fileName, marshaller, cacheTableSize, cacheEntrySize) {<a name="line.344"></a>
<FONT color="green">345</FONT>                            @Override<a name="line.345"></a>
<FONT color="green">346</FONT>                        protected FixedWidthTable&lt;FixedTableRow&gt; openTableFile(int tableIndex, int byteWidth, boolean createIfNeeded) throws IOException {<a name="line.346"></a>
<FONT color="green">347</FONT>                                    if (createIfNeeded) {<a name="line.347"></a>
<FONT color="green">348</FONT>                                            throw new IOException("internal error: read only table");<a name="line.348"></a>
<FONT color="green">349</FONT>                                    }<a name="line.349"></a>
<FONT color="green">350</FONT>                                    boolean refetchReadLock = false;<a name="line.350"></a>
<FONT color="green">351</FONT>                                    try {<a name="line.351"></a>
<FONT color="green">352</FONT>                                            lock.readLock().unlock();<a name="line.352"></a>
<FONT color="green">353</FONT>                                            refetchReadLock = true;<a name="line.353"></a>
<FONT color="green">354</FONT>                                    }<a name="line.354"></a>
<FONT color="green">355</FONT>                                    catch (IllegalMonitorStateException ex) {<a name="line.355"></a>
<FONT color="green">356</FONT>                                            //ignore                                        <a name="line.356"></a>
<FONT color="green">357</FONT>                                    }<a name="line.357"></a>
<FONT color="green">358</FONT>                                    lock.writeLock().lock();<a name="line.358"></a>
<FONT color="green">359</FONT>                                    try {<a name="line.359"></a>
<FONT color="green">360</FONT>                                            VariableWidthTable.this.flush();//TODO optimize, do not always do this<a name="line.360"></a>
<FONT color="green">361</FONT>                                            final FixedWidthTable&lt;FixedTableRow&gt; main;                                <a name="line.361"></a>
<FONT color="green">362</FONT>                                            if (tableIndex == 0) {<a name="line.362"></a>
<FONT color="green">363</FONT>                                                    main = VariableWidthTable.this.primaryTable;<a name="line.363"></a>
<FONT color="green">364</FONT>                                            }<a name="line.364"></a>
<FONT color="green">365</FONT>                                            else {<a name="line.365"></a>
<FONT color="green">366</FONT>                                            //final int byteWidth = getTableByteWidth(1, rawByteWidth);<a name="line.366"></a>
<FONT color="green">367</FONT>                                                    main = VariableWidthTable.this.openSecondaryTable(byteWidth, false /*createIfNeeded*/);<a name="line.367"></a>
<FONT color="green">368</FONT>                                            }<a name="line.368"></a>
<FONT color="green">369</FONT>                                            return main.createReadCopy(lock);<a name="line.369"></a>
<FONT color="green">370</FONT>                                    }<a name="line.370"></a>
<FONT color="green">371</FONT>                                    finally {<a name="line.371"></a>
<FONT color="green">372</FONT>                                            lock.writeLock().unlock();<a name="line.372"></a>
<FONT color="green">373</FONT>                                            if (refetchReadLock) {<a name="line.373"></a>
<FONT color="green">374</FONT>                                                    lock.readLock().lock();<a name="line.374"></a>
<FONT color="green">375</FONT>                                            }<a name="line.375"></a>
<FONT color="green">376</FONT>                                    }<a name="line.376"></a>
<FONT color="green">377</FONT>                            }<a name="line.377"></a>
<FONT color="green">378</FONT>                            private void sync() throws IOException {<a name="line.378"></a>
<FONT color="green">379</FONT>                                    if (VariableWidthTable.this.primaryTable == null) {<a name="line.379"></a>
<FONT color="green">380</FONT>                                            //main editable table is closed, so we are closed, too<a name="line.380"></a>
<FONT color="green">381</FONT>                                            close(false);<a name="line.381"></a>
<FONT color="green">382</FONT>                                            throw new IOException("table already closed");<a name="line.382"></a>
<FONT color="green">383</FONT>                                    }<a name="line.383"></a>
<FONT color="green">384</FONT>                            }<a name="line.384"></a>
<FONT color="green">385</FONT>                            @Override<a name="line.385"></a>
<FONT color="green">386</FONT>                            public E get(int index) throws IOException {<a name="line.386"></a>
<FONT color="green">387</FONT>                                    sync();<a name="line.387"></a>
<FONT color="green">388</FONT>                                    return super.get(index);<a name="line.388"></a>
<FONT color="green">389</FONT>                            }<a name="line.389"></a>
<FONT color="green">390</FONT>                            @Override<a name="line.390"></a>
<FONT color="green">391</FONT>                            public int size() throws IOException {<a name="line.391"></a>
<FONT color="green">392</FONT>                                    sync();<a name="line.392"></a>
<FONT color="green">393</FONT>                                    return super.size();<a name="line.393"></a>
<FONT color="green">394</FONT>                            }<a name="line.394"></a>
<FONT color="green">395</FONT>                            @Override<a name="line.395"></a>
<FONT color="green">396</FONT>                            public int add(E entity) throws IOException {<a name="line.396"></a>
<FONT color="green">397</FONT>                                    throw new IOException("unmodifyable read copy table");                                                          <a name="line.397"></a>
<FONT color="green">398</FONT>                            }<a name="line.398"></a>
<FONT color="green">399</FONT>                            @Override<a name="line.399"></a>
<FONT color="green">400</FONT>                            public void set(int index, E entity) throws IOException {<a name="line.400"></a>
<FONT color="green">401</FONT>                                    throw new IOException("unmodifyable read copy table");                                                          <a name="line.401"></a>
<FONT color="green">402</FONT>                            }<a name="line.402"></a>
<FONT color="green">403</FONT>                            @Override<a name="line.403"></a>
<FONT color="green">404</FONT>                            public void swap(int indexA, int indexB) throws IOException {<a name="line.404"></a>
<FONT color="green">405</FONT>                                    throw new IOException("unmodifyable read copy table");                                                          <a name="line.405"></a>
<FONT color="green">406</FONT>                            }<a name="line.406"></a>
<FONT color="green">407</FONT>                            @Override<a name="line.407"></a>
<FONT color="green">408</FONT>                            public void remove(int index) throws IOException {<a name="line.408"></a>
<FONT color="green">409</FONT>                                    throw new IOException("unmodifyable read copy table");                                                          <a name="line.409"></a>
<FONT color="green">410</FONT>                            }<a name="line.410"></a>
<FONT color="green">411</FONT>                            @Override<a name="line.411"></a>
<FONT color="green">412</FONT>                            public void removeAll() throws IOException {<a name="line.412"></a>
<FONT color="green">413</FONT>                                    throw new IOException("unmodifyable read copy table");                                                          <a name="line.413"></a>
<FONT color="green">414</FONT>                            }<a name="line.414"></a>
<FONT color="green">415</FONT>                            @Override<a name="line.415"></a>
<FONT color="green">416</FONT>                            public void flush() throws IOException {<a name="line.416"></a>
<FONT color="green">417</FONT>                                    //ignore, don't write anything here<a name="line.417"></a>
<FONT color="green">418</FONT>                            }<a name="line.418"></a>
<FONT color="green">419</FONT>                            @Override<a name="line.419"></a>
<FONT color="green">420</FONT>                            public void close(boolean erase) throws IOException {<a name="line.420"></a>
<FONT color="green">421</FONT>                                    if (erase) {<a name="line.421"></a>
<FONT color="green">422</FONT>                                            throw new UnsupportedOperationException("unmodifyable read copy table");                                                        <a name="line.422"></a>
<FONT color="green">423</FONT>                                    }<a name="line.423"></a>
<FONT color="green">424</FONT>                                    super.close(false);//close the tables<a name="line.424"></a>
<FONT color="green">425</FONT>                            }<a name="line.425"></a>
<FONT color="green">426</FONT>                            @Override<a name="line.426"></a>
<FONT color="green">427</FONT>                            protected void finalize() throws Throwable {<a name="line.427"></a>
<FONT color="green">428</FONT>                                    close(false);<a name="line.428"></a>
<FONT color="green">429</FONT>                            }<a name="line.429"></a>
<FONT color="green">430</FONT>                    };<a name="line.430"></a>
<FONT color="green">431</FONT>                    tbl.primaryTable = tbl.openPrimaryTable();<a name="line.431"></a>
<FONT color="green">432</FONT>                    return tbl;<a name="line.432"></a>
<FONT color="green">433</FONT>        }<a name="line.433"></a>
<FONT color="green">434</FONT>        <a name="line.434"></a>
<FONT color="green">435</FONT>        public E get(int index) throws IOException {<a name="line.435"></a>
<FONT color="green">436</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.436"></a>
<FONT color="green">437</FONT>            <a name="line.437"></a>
<FONT color="green">438</FONT>            byteBuffer.reset();<a name="line.438"></a>
<FONT color="green">439</FONT>            <a name="line.439"></a>
<FONT color="green">440</FONT>            final FixedTableRow row0 = primaryTable.get(index);<a name="line.440"></a>
<FONT color="green">441</FONT>            row0.putBytesTo(byteBuffer);<a name="line.441"></a>
<FONT color="green">442</FONT>            <a name="line.442"></a>
<FONT color="green">443</FONT>            final int tbl1 = row0.getInt(0);<a name="line.443"></a>
<FONT color="green">444</FONT>            final int ind1 = row0.getInt(1);<a name="line.444"></a>
<FONT color="green">445</FONT>            if (tbl1 != 0) {<a name="line.445"></a>
<FONT color="green">446</FONT>                    final FixedWidthTable&lt;FixedTableRow&gt; secondaryTable = openSecondaryTable(<a name="line.446"></a>
<FONT color="green">447</FONT>                                    tbl1, false /*createIfNeeded*/);<a name="line.447"></a>
<FONT color="green">448</FONT>                final FixedTableRow row1 = secondaryTable.get(ind1);<a name="line.448"></a>
<FONT color="green">449</FONT>                row1.putBytesTo(byteBuffer);<a name="line.449"></a>
<FONT color="green">450</FONT>    //            if (ind1 &lt; 10) {<a name="line.450"></a>
<FONT color="green">451</FONT>    //                System.out.println("r[" + primaryTable.size() + <a name="line.451"></a>
<FONT color="green">452</FONT>    //                        "/" + secondaryTable.size() + "] = " + row0.toString() + row1);<a name="line.452"></a>
<FONT color="green">453</FONT>    //            }<a name="line.453"></a>
<FONT color="green">454</FONT>            }<a name="line.454"></a>
<FONT color="green">455</FONT>            <a name="line.455"></a>
<FONT color="green">456</FONT>            return entityMarshaller.readFrom(byteBuffer.getDataInputStream());<a name="line.456"></a>
<FONT color="green">457</FONT>        }<a name="line.457"></a>
<FONT color="green">458</FONT>    <a name="line.458"></a>
<FONT color="green">459</FONT>        public void remove(int index) throws IOException {<a name="line.459"></a>
<FONT color="green">460</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.460"></a>
<FONT color="green">461</FONT>            <a name="line.461"></a>
<FONT color="green">462</FONT>            //just for consistent naming throughout this method<a name="line.462"></a>
<FONT color="green">463</FONT>            final FixedWidthTable&lt;FixedTableRow&gt; fwt0 = primaryTable;<a name="line.463"></a>
<FONT color="green">464</FONT>            final int ind0 = index;<a name="line.464"></a>
<FONT color="green">465</FONT>            <a name="line.465"></a>
<FONT color="green">466</FONT>            FixedTableRow row0 = (FixedTableRow)fwt0.getEntityMarshaller();<a name="line.466"></a>
<FONT color="green">467</FONT>            row0.setIndexOnlyMode(true);<a name="line.467"></a>
<FONT color="green">468</FONT>            try {<a name="line.468"></a>
<FONT color="green">469</FONT>                    row0 = fwt0.get(ind0);<a name="line.469"></a>
<FONT color="green">470</FONT>            }<a name="line.470"></a>
<FONT color="green">471</FONT>            finally {<a name="line.471"></a>
<FONT color="green">472</FONT>                    row0.setIndexOnlyMode(false);<a name="line.472"></a>
<FONT color="green">473</FONT>            }<a name="line.473"></a>
<FONT color="green">474</FONT>            <a name="line.474"></a>
<FONT color="green">475</FONT>            final int tbl1 = row0.getInt(0);<a name="line.475"></a>
<FONT color="green">476</FONT>            final int ind1 = row0.getInt(1);<a name="line.476"></a>
<FONT color="green">477</FONT>            <a name="line.477"></a>
<FONT color="green">478</FONT>            //NOTE: the following actions are performed<a name="line.478"></a>
<FONT color="green">479</FONT>            //1a) delete entry in primary table, which moves the last entry to the<a name="line.479"></a>
<FONT color="green">480</FONT>            //    gap position<a name="line.480"></a>
<FONT color="green">481</FONT>            //1b) if the moved entry has a corresponding entry in the secondary <a name="line.481"></a>
<FONT color="green">482</FONT>            //    table, its back pointer has to be updated<a name="line.482"></a>
<FONT color="green">483</FONT>            //2a) if the deleted entry had an entry in the secondary table, also<a name="line.483"></a>
<FONT color="green">484</FONT>            //    delete it, again moving the last table entry to the gap position<a name="line.484"></a>
<FONT color="green">485</FONT>            //2b) the primary entry corresponding to the moved entry has to be<a name="line.485"></a>
<FONT color="green">486</FONT>            //    updated, too<a name="line.486"></a>
<FONT color="green">487</FONT>            //2c) delete secondary table if it is empty<a name="line.487"></a>
<FONT color="green">488</FONT>            <a name="line.488"></a>
<FONT color="green">489</FONT>            //1a) delete primary<a name="line.489"></a>
<FONT color="green">490</FONT>            fwt0.remove(ind0);<a name="line.490"></a>
<FONT color="green">491</FONT>            final int last0 = primaryTable.size();<a name="line.491"></a>
<FONT color="green">492</FONT>            <a name="line.492"></a>
<FONT color="green">493</FONT>            //1b) update secondary of moved<a name="line.493"></a>
<FONT color="green">494</FONT>            if (ind0 != last0) {<a name="line.494"></a>
<FONT color="green">495</FONT>                row0.setIndexOnlyMode(true);<a name="line.495"></a>
<FONT color="green">496</FONT>                try {<a name="line.496"></a>
<FONT color="green">497</FONT>                    row0 = fwt0.get(ind0);<a name="line.497"></a>
<FONT color="green">498</FONT>                }<a name="line.498"></a>
<FONT color="green">499</FONT>                finally {<a name="line.499"></a>
<FONT color="green">500</FONT>                    row0.setIndexOnlyMode(false);<a name="line.500"></a>
<FONT color="green">501</FONT>                }<a name="line.501"></a>
<FONT color="green">502</FONT>                final int tbl2 = row0.getInt(0);<a name="line.502"></a>
<FONT color="green">503</FONT>                final int ind2 = row0.getInt(1);<a name="line.503"></a>
<FONT color="green">504</FONT>                <a name="line.504"></a>
<FONT color="green">505</FONT>                if (tbl2 != 0) {<a name="line.505"></a>
<FONT color="green">506</FONT>                    final FixedWidthTable&lt;FixedTableRow&gt; fwt2 = openSecondaryTable(<a name="line.506"></a>
<FONT color="green">507</FONT>                                    tbl2, false /*createIfNeeded*/);<a name="line.507"></a>
<FONT color="green">508</FONT>                    final FixedTableRow row2 = (FixedTableRow)fwt2.getEntityMarshaller();<a name="line.508"></a>
<FONT color="green">509</FONT>                    row2.setIndexOnlyMode(true);<a name="line.509"></a>
<FONT color="green">510</FONT>                    try {<a name="line.510"></a>
<FONT color="green">511</FONT>                        row2.setInt(0, ind0);<a name="line.511"></a>
<FONT color="green">512</FONT>                            fwt2.set(ind2, row2);<a name="line.512"></a>
<FONT color="green">513</FONT>                    }<a name="line.513"></a>
<FONT color="green">514</FONT>                    finally {<a name="line.514"></a>
<FONT color="green">515</FONT>                            row2.setIndexOnlyMode(false);<a name="line.515"></a>
<FONT color="green">516</FONT>                    }<a name="line.516"></a>
<FONT color="green">517</FONT>                }<a name="line.517"></a>
<FONT color="green">518</FONT>            }<a name="line.518"></a>
<FONT color="green">519</FONT>            <a name="line.519"></a>
<FONT color="green">520</FONT>            //2a) delete secondary<a name="line.520"></a>
<FONT color="green">521</FONT>            if (tbl1 != 0) {<a name="line.521"></a>
<FONT color="green">522</FONT>                final FixedWidthTable&lt;FixedTableRow&gt; fwt1 = openSecondaryTable(<a name="line.522"></a>
<FONT color="green">523</FONT>                                    tbl1, false /*createIfNeeded*/);<a name="line.523"></a>
<FONT color="green">524</FONT>                fwt1.remove(ind1);<a name="line.524"></a>
<FONT color="green">525</FONT>                final int last1 = fwt1.size();<a name="line.525"></a>
<FONT color="green">526</FONT>                <a name="line.526"></a>
<FONT color="green">527</FONT>                //2b) update primary of moved<a name="line.527"></a>
<FONT color="green">528</FONT>                if (ind1 != last1) {<a name="line.528"></a>
<FONT color="green">529</FONT>                    FixedTableRow row1 = (FixedTableRow)fwt1.getEntityMarshaller();<a name="line.529"></a>
<FONT color="green">530</FONT>                    row1.setIndexOnlyMode(true);<a name="line.530"></a>
<FONT color="green">531</FONT>                    try {<a name="line.531"></a>
<FONT color="green">532</FONT>                            row1 = fwt1.get(ind1);<a name="line.532"></a>
<FONT color="green">533</FONT>                    }<a name="line.533"></a>
<FONT color="green">534</FONT>                    finally {<a name="line.534"></a>
<FONT color="green">535</FONT>                            row1.setIndexOnlyMode(false);<a name="line.535"></a>
<FONT color="green">536</FONT>                    }<a name="line.536"></a>
<FONT color="green">537</FONT>                    final int ind0b = row1.getInt(0);<a name="line.537"></a>
<FONT color="green">538</FONT>    <a name="line.538"></a>
<FONT color="green">539</FONT>                    row0.setIndexOnlyMode(true);<a name="line.539"></a>
<FONT color="green">540</FONT>                    try {<a name="line.540"></a>
<FONT color="green">541</FONT>                            row0.setInt(0, tbl1);<a name="line.541"></a>
<FONT color="green">542</FONT>                            row0.setInt(1, ind1);<a name="line.542"></a>
<FONT color="green">543</FONT>                            fwt0.set(ind0b, row0);<a name="line.543"></a>
<FONT color="green">544</FONT>                    }<a name="line.544"></a>
<FONT color="green">545</FONT>                    finally {<a name="line.545"></a>
<FONT color="green">546</FONT>                            row0.setIndexOnlyMode(false);<a name="line.546"></a>
<FONT color="green">547</FONT>                    }<a name="line.547"></a>
<FONT color="green">548</FONT>                }<a name="line.548"></a>
<FONT color="green">549</FONT>                <a name="line.549"></a>
<FONT color="green">550</FONT>                //2c) delete if empt<a name="line.550"></a>
<FONT color="green">551</FONT>                if (fwt1.size() == 0) {<a name="line.551"></a>
<FONT color="green">552</FONT>                    fwt1.close(true);<a name="line.552"></a>
<FONT color="green">553</FONT>                    final File file = getTableFile(1, tbl1);<a name="line.553"></a>
<FONT color="green">554</FONT>                    file.delete();<a name="line.554"></a>
<FONT color="green">555</FONT>                    if (secondaryTables.remove(file) != fwt1) {<a name="line.555"></a>
<FONT color="green">556</FONT>                            throw new IOException("internal error, should have deleted file of current table: " + file.getAbsolutePath());<a name="line.556"></a>
<FONT color="green">557</FONT>                    }<a name="line.557"></a>
<FONT color="green">558</FONT>                }<a name="line.558"></a>
<FONT color="green">559</FONT>            }<a name="line.559"></a>
<FONT color="green">560</FONT>            <a name="line.560"></a>
<FONT color="green">561</FONT>        }<a name="line.561"></a>
<FONT color="green">562</FONT>        <a name="line.562"></a>
<FONT color="green">563</FONT>        public void removeAll() throws IOException {<a name="line.563"></a>
<FONT color="green">564</FONT>            final int primaryByteWidth = primaryTable.getByteWidth() - 8;<a name="line.564"></a>
<FONT color="green">565</FONT>            close(true);<a name="line.565"></a>
<FONT color="green">566</FONT>            eraseTableFiles(folder, fileName);<a name="line.566"></a>
<FONT color="green">567</FONT>            primaryTable = createPrimaryTable(primaryByteWidth);<a name="line.567"></a>
<FONT color="green">568</FONT>        }<a name="line.568"></a>
<FONT color="green">569</FONT>    <a name="line.569"></a>
<FONT color="green">570</FONT>        public void set(int index, E entity) throws IOException {<a name="line.570"></a>
<FONT color="green">571</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.571"></a>
<FONT color="green">572</FONT>    <a name="line.572"></a>
<FONT color="green">573</FONT>            //TODO do this more efficiently<a name="line.573"></a>
<FONT color="green">574</FONT>            add(entity);<a name="line.574"></a>
<FONT color="green">575</FONT>            remove(index);<a name="line.575"></a>
<FONT color="green">576</FONT>        }<a name="line.576"></a>
<FONT color="green">577</FONT>        <a name="line.577"></a>
<FONT color="green">578</FONT>        public void swap(int indexA, int indexB) throws IOException {<a name="line.578"></a>
<FONT color="green">579</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.579"></a>
<FONT color="green">580</FONT>            if (indexA == indexB) return;<a name="line.580"></a>
<FONT color="green">581</FONT>            <a name="line.581"></a>
<FONT color="green">582</FONT>            //!!! DOES NOT WORK !!! <a name="line.582"></a>
<FONT color="green">583</FONT>            //since table rows are always same instance: primaryTable.swap(indexA, indexB);<a name="line.583"></a>
<FONT color="green">584</FONT>    <a name="line.584"></a>
<FONT color="green">585</FONT>            //we must update the back pointers in the secondary tables<a name="line.585"></a>
<FONT color="green">586</FONT>            final int tblA, tblB, indA, indB;<a name="line.586"></a>
<FONT color="green">587</FONT>            <a name="line.587"></a>
<FONT color="green">588</FONT>            //1) read primary table and get secondary table info<a name="line.588"></a>
<FONT color="green">589</FONT>            byteBuffer.reset();<a name="line.589"></a>
<FONT color="green">590</FONT>            <a name="line.590"></a>
<FONT color="green">591</FONT>            //1a) get entity A and secondary table info for A<a name="line.591"></a>
<FONT color="green">592</FONT>            FixedTableRow row = (FixedTableRow)primaryTable.getEntityMarshaller();<a name="line.592"></a>
<FONT color="green">593</FONT>            row = primaryTable.get(indexA);<a name="line.593"></a>
<FONT color="green">594</FONT>            tblA = row.getInt(0);<a name="line.594"></a>
<FONT color="green">595</FONT>            indA = row.getInt(1);<a name="line.595"></a>
<FONT color="green">596</FONT>            <a name="line.596"></a>
<FONT color="green">597</FONT>            //store entity A in byteBuffer<a name="line.597"></a>
<FONT color="green">598</FONT>            row.putBytesTo(byteBuffer);<a name="line.598"></a>
<FONT color="green">599</FONT>            <a name="line.599"></a>
<FONT color="green">600</FONT>            //1b) get entity B and secondary table info for B<a name="line.600"></a>
<FONT color="green">601</FONT>            row = primaryTable.get(indexB);<a name="line.601"></a>
<FONT color="green">602</FONT>            tblB = row.getInt(0);<a name="line.602"></a>
<FONT color="green">603</FONT>            indB = row.getInt(1);<a name="line.603"></a>
<FONT color="green">604</FONT>    <a name="line.604"></a>
<FONT color="green">605</FONT>            //2) swap primary table entries<a name="line.605"></a>
<FONT color="green">606</FONT>            <a name="line.606"></a>
<FONT color="green">607</FONT>            //2a) write entity B to indexA<a name="line.607"></a>
<FONT color="green">608</FONT>            primaryTable.set(indexA, row);<a name="line.608"></a>
<FONT color="green">609</FONT>    <a name="line.609"></a>
<FONT color="green">610</FONT>            //2b) write entity A to indexB<a name="line.610"></a>
<FONT color="green">611</FONT>            row.getBytesFrom(byteBuffer);<a name="line.611"></a>
<FONT color="green">612</FONT>            row.setInt(0, tblA);<a name="line.612"></a>
<FONT color="green">613</FONT>            row.setInt(1, indA);<a name="line.613"></a>
<FONT color="green">614</FONT>            primaryTable.set(indexB, row);<a name="line.614"></a>
<FONT color="green">615</FONT>            <a name="line.615"></a>
<FONT color="green">616</FONT>            //3) update back pointers in secondary tables <a name="line.616"></a>
<FONT color="green">617</FONT>            if (tblA != 0) {<a name="line.617"></a>
<FONT color="green">618</FONT>                    //3a) update back pointer of secondary A<a name="line.618"></a>
<FONT color="green">619</FONT>                    final FixedWidthTable&lt;FixedTableRow&gt; secA = openSecondaryTable(<a name="line.619"></a>
<FONT color="green">620</FONT>                                    tblA, false /*createIfNeeded*/);<a name="line.620"></a>
<FONT color="green">621</FONT>                final FixedTableRow rowA = secA.get(indA);<a name="line.621"></a>
<FONT color="green">622</FONT>                rowA.setIndexOnlyMode(true);<a name="line.622"></a>
<FONT color="green">623</FONT>                try {<a name="line.623"></a>
<FONT color="green">624</FONT>                    rowA.setInt(0, indexB);<a name="line.624"></a>
<FONT color="green">625</FONT>                    secA.set(indA, rowA);<a name="line.625"></a>
<FONT color="green">626</FONT>                }<a name="line.626"></a>
<FONT color="green">627</FONT>                finally {<a name="line.627"></a>
<FONT color="green">628</FONT>                    rowA.setIndexOnlyMode(false);<a name="line.628"></a>
<FONT color="green">629</FONT>                }<a name="line.629"></a>
<FONT color="green">630</FONT>            }<a name="line.630"></a>
<FONT color="green">631</FONT>            if (tblB != 0) {<a name="line.631"></a>
<FONT color="green">632</FONT>                    //3b) update back pointer of secondary B<a name="line.632"></a>
<FONT color="green">633</FONT>                    final FixedWidthTable&lt;FixedTableRow&gt; secB = openSecondaryTable(<a name="line.633"></a>
<FONT color="green">634</FONT>                                    tblB, false /*createIfNeeded*/);<a name="line.634"></a>
<FONT color="green">635</FONT>                final FixedTableRow rowB = secB.get(indB);<a name="line.635"></a>
<FONT color="green">636</FONT>                rowB.setIndexOnlyMode(true);<a name="line.636"></a>
<FONT color="green">637</FONT>                try {<a name="line.637"></a>
<FONT color="green">638</FONT>                    rowB.setInt(0, indexA);<a name="line.638"></a>
<FONT color="green">639</FONT>                    secB.set(indB, rowB);<a name="line.639"></a>
<FONT color="green">640</FONT>                }<a name="line.640"></a>
<FONT color="green">641</FONT>                finally {<a name="line.641"></a>
<FONT color="green">642</FONT>                    rowB.setIndexOnlyMode(false);<a name="line.642"></a>
<FONT color="green">643</FONT>                }<a name="line.643"></a>
<FONT color="green">644</FONT>            }<a name="line.644"></a>
<FONT color="green">645</FONT>    <a name="line.645"></a>
<FONT color="green">646</FONT>        }<a name="line.646"></a>
<FONT color="green">647</FONT>    <a name="line.647"></a>
<FONT color="green">648</FONT>        public int size() throws IOException {<a name="line.648"></a>
<FONT color="green">649</FONT>            if (primaryTable == null) throw new IOException("table already closed");<a name="line.649"></a>
<FONT color="green">650</FONT>            return primaryTable.size();<a name="line.650"></a>
<FONT color="green">651</FONT>        }<a name="line.651"></a>
<FONT color="green">652</FONT>    <a name="line.652"></a>
<FONT color="green">653</FONT>    }<a name="line.653"></a>




























































</PRE>
</BODY>
</HTML>
